registerOutputEvent(Player,AddMetal,"int 0 400 200");
registerOutputEvent(Player,SetMetal,"int 0 400 400");

if(!$VCE::Server)
{
	registerSpecialVar(Player,"Metal","%this.metal");
}

function Player::AddMetal(%this,%value)
{
	if(isObject(%this))
	{
		%this.metal += %value;
	}
}
function Player::SetMetal(%this,%value)
{
	if(isObject(%this))
	{
		%this.metal = %value;
	}
}

//Package to add some stuff
//ProjectileCollision stuff is to make it so that if you wrench the sentry with the TF2 wrench, you will heal it.
package TF2Sentry
{
	function tf2WrenchImage::onHitObject(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
	{
		if(%col.dataBlock $= "")
		{
			parent::onHitObject(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit);
			return;
		}
		
		if(%col.dataBlock.getName() $= "playerSentryTop")
			%sentry = %col;
		if(%col.dataBlock.getName() $= "playerSentryBottom")
			{
				%sentry = %col.sentryTop;
				if($TF2Sentry::MetalUsage == true)
				{
					if(%obj.metal >= $TF2Sentry::Healrate)
					{
						%col.setDamageLevel(%col.getDamageLevel()-$TF2Sentry::Healrate);
						%sentry.setDamageLevel(%col.getDamageLevel()-$TF2Sentry::Healrate);
						serverPlay3D(sentryHealSound, %sentry.getPosition());
						bottomprint(%obj.client,"<just:center><font:impact:38><color:ffffff>Healing the sentry..." @ %col.getDatablock().maxDamage - %col.getDamageLevel() @ "<color:fff000><font:impact:32> out of 150 hit points left." ,5);
						%obj.metal -= %col.getDamageLevel();
					}
					else
						bottomprint(%obj.client,"<just:center><font:impact:38><color:ffffff>Not enough metal (" @ %obj.metal @ "/" @ %col.getDamageLevel() @ ").",5);
				}
				if($TF2Sentry::MetalUsage != true)
				{
					%col.setDamageLevel(%col.getDamageLevel()-$TF2Sentry::Healrate);
					%sentry.setDamageLevel(%col.getDamageLevel()-$TF2Sentry::Healrate);
					serverPlay3D(sentryHealSound, %sentry.getPosition());
					bottomprint(%obj.client,"<just:center><font:impact:38><color:ffffff>Healing the sentry..." @ %col.getDatablock().maxDamage - %col.getDamageLevel() @ "<color:fff000><font:impact:32> out of 150 hit points left." ,5);
				}
			}
		
		if(!isObject(%sentry))
		{
			parent::onHitObject(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit);
			return;
		}
		
		//note: %sentry will always be the sentry's top
		if($TF2Sentry::MetalUsage == true)
		{
			if(%obj.metal >= $TF2Sentry::Upgraderate && %sentry.sentryLevel != 3)
			{
				%sentry.sentryXP += $TF2Sentry::Upgraderate;
				%kit = %sentry.sentryKit;
				%level = %sentry.sentryLevel;
				%obj.metal -= $TF2Sentry::Upgraderate;
			}
			else if(%obj.metal > 0 && %sentry.sentryLevel != 3)
			{
				%sentry.sentryXP += %obj.metal;
				%kit = %sentry.sentryKit;
				%level = %sentry.sentryLevel;
				%obj.metal = 0;
			}
			else
				centerprint(%obj.client,"<just:center><font:impact:38><color:ffffff>No metal left.",5);
		}
		if($TF2Sentry::MetalUsage != true)
		{
			%sentry.sentryXP += $TF2Wrench::Upgraderate;
			%kit = %sentry.sentryKit;
			%level = %sentry.sentryLevel;
		}

		if(%sentry.sentryXP >= $sentryUpgradeThreshold_[%kit @ "_" @ %level + 1] && $sentryImage_[%kit @ "_" @ %level + 1] !$= "")
		{
			//UPRADIN' A SENTRY
			%sentry.sentryLevel++;
			%sentry.sentryXP = 0; //reset XP
			%level++;
			%sentry.setVelocity("0 0" SPC getWord(%obj.getVelocity(),4));
			%sentry.mountImage($sentryImage_[%kit @ "_" @ %level], 0);
			serverPlay3D(sentryUpgradeSound, %sentry.getPosition());
			messageClient(%obj.client, "", "\c3Sentry upgraded!");
			%pos = %sentry.getPosition();

			%p = new Projectile()
			{
				dataBlock = toolboxExplosion2Projectile;
				initialPosition = %pos;
				initialVelocity = "0 0 1";
				client = %obj.client;
				sourceClient = %obj.client;
			};
			MissionCleanup.add(%p);
			%p.explode();
		}
		if($TF2Sentry::MetalUsage == true)
		{
			if(%obj.metal > $TF2Sentry::Upgraderate)
			{
				if(%sentry.sentryLevel == 1)
				{
					centerprint(%obj.client,"<br><br><br><br><br><br><font:impact:38><color:ffffff>" @ %sentry.sentryXP @ "/" @ $sentryUpgradeThreshold_Default_2 @ "<color:fff000><font:impact:32> upgrade power: Sentry is currently level <font:impact:38><color:ffffff>1." ,5);
				}
				if(%sentry.sentryLevel == 2)
				{
					centerprint(%obj.client,"<br><br><br><br><br><br><font:impact:38><color:ffffff>" @ %sentry.sentryXP @ "/" @ $sentryUpgradeThreshold_Default_3 @ "<color:fff000><font:impact:32> upgrade power: Sentry is currently level <font:impact:38><color:ffffff>2." ,5);
				}
				if (%sentry.sentryLevel == 3)
				{
					centerprint(%obj.client,"<br><br><br><br><br><br><color:fff000><font:impact:32>This sentry is already fully upgraded, at level <font:impact:38><color:ffffff>3." ,5);
				}
			}
		}
	}
	
	function PlaceSentryImage::onMount(%this, %obj, %slot)
	{
		if($TF2Sentry::MetalUsage)
		{
			%obj.playthread(1, armReadyBoth);
			if(%obj.metal < $TF2Sentry::SentryMetalcost)
			{
				centerprint(%obj.client,"<just:center><font:impact:38><color:ffffff>Not enough metal (" @ %obj.metal @ "/" @ %col.getDamageLevel() @ ").",5);
				serverCmdUnUseTool(%obj.client);
				%obj.playThread(2, undo);
				return;
			}
		}
		else
			parent::onMount(%this, %obj, %slot);
	}
	
	function createSentryAtPlayer(%player)
	{
		if($TF2Sentry::MetalUsage)
		{
			if(%player.metal >= $TF2Sentry::SentryMetalcost)
			{
				%player.metal -= $TF2Sentry::SentryMetalcost;
				parent::createSentryAtPlayer(%player);
			}
			else
			{
				centerprint(%obj.client,"Not enough metal (" @ %player.metal @ "/" @ $TF2Sentry::SentryMetalcost @ ").",5);
			}
		}
		else
			parent::createSentryAtPlayer(%player);
	}
};
if(isPackage(TF2Sentry))
	deactivatePackage(TF2Sentry);
ActivatePackage(TF2Sentry);